//Team: 	Revolver 




/**
 * @file
 * 	This file is the header for the Cfunc class which will serve as a 
 * 	class wrapper for any C functions we might need to use
 * @brief
 * 	header for Cfunc class
*/

//includes
#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include <string>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

using namespace std;

//if not defined, define
#ifndef _CFUNC_H_
#define _CFUNC_H_

/**
 * @brief Cfunc class which wraps C-functions
 * @class Cfunc cFunctions.h "cFunctions.h"
 * The Cfunc class is a wrapper class for all C-style functions
 * we may have to use
*/
class Cfunc{

	public:
		///constructor for Cfunc class
		Cfunc();
	
		///access function for fHomeDir
		string getHome();

		///checks if open works on inFileName
		bool canOpenFile(string inFileName, int inFlags);

		///backs up output file to inFileName~ and makes new file inFileName
		bool createBackup(string inFilename);

		///checks if files are same size
		bool areFilesSameSize(string inRefFile, string inTestFile);


		///creates a temporary file fd.temp
		bool createTempFile();

		///deletes temp file if it exists
		void deleteTempFile();


		//flags
		int read;			//O_RDONLY
		int write;			//O_WRONLY
		int readWrite;		//O_RDWR
		int create;			//O_CREAT
		int append;			//O_APPEND

	private:
		string homeDir;
	
}; //end of Cfunc class

#endif
