//Team:  Revolver




/**
 * @file
 *		This file contains our implementation for preCondition and 
 * 	postCondition functions
 * @brief
 *		Our implementation of an preCondition and postCondition
*/

#include "condition.h"


/**
 * This function acts like an assert for pre-conditions, taking in
 * the condition to be asserted, and a string for the method whose
 * pre-condition is in question
 * @param inCondition a bool
 * @param inMethod a string
 * @throw PreConditionFailed
*/
void preCondition(bool inCondition, string inMethod)
{
	
	/** @pre TRUE */
	/** @post PreConditionFailed exception thrown if inCondition is false */

	if(!inCondition)
		throw( PreConditionFailed(inMethod) );

}//end of preCondition function


/**
 * This function acts like an assert for post-conditions, taking in
 * the condition to be asserted, and a string for the method whose
 * post-condition is in question
 * @param inCondition a bool
 * @param inMethod a string
 * @throw PostConditionFailed
*/
void postCondition(bool inCondition, string inMethod)
{

	/** @pre TRUE */
	/** @post PostConditionFailed exception thrown if inCondition is false */

	if(!inCondition)
		throw( PostConditionFailed(inMethod) );

}//end of preCondition function

