//Team:  Revolver




/**
 * @file
 *		This file contains our version of assert() which will throw an
 * 	exception instead of just halting the program.  This will allow
 * 	for us to catch these asserts during our unit testing it is called
 * 	condition()
 * @brief
 *		Header file for preCondition and postCondition functions
*/

#include <iostream>
#include <string>

using namespace std;

#ifndef _CONDITION_H_
#define _CONDITION_H_


/**
 * @brief PreConditionFailed exception structure, with string to print
 * This stucture is fo a PreConditionFailed exception, it holds a string
 * for what function/method's pre-condition failed
*/
struct PreConditionFailed
{
	//constructor
	PreConditionFailed(string inMethod) { method = inMethod; }

	//string for what function/method failed pre-condition
	string method;
}; // end of PreConditionFailed struct


/**
 * @brief PostConditionFailed exception structure, with string to print
 * This stucture is fo a PostConditionFailed exception, it holds a string
 * for what function/method's post-condition failed
*/
struct PostConditionFailed
{
	//constructor
	PostConditionFailed(string inMethod) { method = inMethod; }

	string method;

}; //end of PostConditionFailed struct


///preCondition checks condition and throws exception if false
void preCondition(bool inCondition, string inMethod);

///postCondition checks condition and throws exception if false
void postCondition(bool inCondition, string inMethod);

#endif
